package com.tofly.toflyServer.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.ParserConfig;

/**
 * 解除fastJson 转换安全限制
 * @author zhoux
 *
 */
@Component
public class Utils {
	
   /**
    *解除fastJson 转换安全限制 	
    */
   @PostConstruct
   public void fastJsonSecruity() {
	   ParserConfig.getGlobalInstance().setAutoTypeSupport(true); 
   }
   
   
   
   
   /**
    * 拆分集合
    * @param datas
    * @param splitSize
    * @param <T>
    * @return
    */
   public static <T> List<List<T>> spliceArrays(List<T> datas, int splitSize) {
       if (datas == null ) {
           return  null;
       }
       int totalSize = datas.size();
       int count = (totalSize % splitSize == 0) ?
               (totalSize / splitSize) : (totalSize/splitSize+1);
    
       List<List<T>> rows = new ArrayList<>();
    
       for (int i = 0; i < count;i++) {
    
           List<T> cols = datas.subList(i * splitSize,
                   (i == count - 1) ? totalSize : splitSize * (i + 1));
           rows.add(cols);
       }
       return rows;
   }
   
   
   
}
